[VERTEX SHADER]
varying vec2  TexCoord;
void main(void) 
{
    gl_Position    = ftransform();    
	TexCoord 		= vec2(gl_MultiTexCoord0);
}

[FRAGMENT SHADER]
uniform sampler2D Texture;
uniform vec2 LensCenter;
uniform vec2 ScreenCenter;
uniform vec2 Scale;
uniform vec2 ScaleIn;
uniform vec4 HmdWarpParam;
varying vec2 TexCoord;

vec2 OculusWarp(vec2 in01)
{
   vec2 theta = (in01 - LensCenter) * ScaleIn; // Scales to [-1, 1]
   float rSq = theta.x * theta.x + theta.y * theta.y;
   vec2 rvector = theta * (HmdWarpParam.x + 
							HmdWarpParam.y * rSq +
							HmdWarpParam.z * rSq * rSq +
							HmdWarpParam.w * rSq * rSq * rSq);
   return LensCenter + Scale * rvector ;
}
/*
void main(){   
	vec2 tc = OculusWarp(TexCoord);
	if (any(bvec2(clamp(tc,ScreenCenter-vec2(0.25,0.5), ScreenCenter+vec2(0.25,0.5)) - tc)))
		discard;//gl_FragColor = vec4(1.0,0.0,0.0, 1.0);
	else  
		gl_FragColor = texture(Texture, tc);
 
}
*/
uniform vec4 ChromAbParam;

void main(){
	vec2 theta = (TexCoord - LensCenter) * ScaleIn; // Scales to [-1, 1]
	float rSq = theta.x * theta.x + theta.y * theta.y;
	vec2 theta1 = theta * (HmdWarpParam.x + 
							HmdWarpParam.y * rSq +
							HmdWarpParam.z * rSq * rSq +
							HmdWarpParam.w * rSq * rSq * rSq);
	// Detect whether blue texture coordinates are out of range
	// since these will scaled out the furthest.
	vec2 thetaBlue = theta1 * (ChromAbParam.z + ChromAbParam.w * rSq);
	vec2 tcBlue = LensCenter + Scale * thetaBlue;
	if (any(bvec2(clamp(tcBlue, ScreenCenter -vec2(0.25,0.5),	ScreenCenter + vec2(0.25, 0.5)) - tcBlue)))
		discard;
	// Now do blue texture lookup.
	float blue = texture(Texture, tcBlue).b;
	// Do green lookup (no scaling).
	vec2 tcGreen = LensCenter + Scale * theta1;
	float green = texture(Texture, tcGreen).g;
	// Do red scale and lookup.
	vec2 thetaRed = theta1 * (ChromAbParam.x + ChromAbParam.y * rSq);
	vec2 tcRed = LensCenter + Scale * thetaRed;
	float red = texture(Texture, tcRed).r;
	gl_FragColor = vec4(red, green, blue, 1);
}